import 'package:flame/components.dart';
import 'package:flame/flame.dart';
import 'package:flame/game.dart';
import 'package:flame/sprite.dart';
import 'package:flame_digit/flame_digit.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

class MyGame extends BaseGame {
  late FlameDigitComponent digitComponent;
  late DigitComponent digitComponent2;

  MyGame() {}

  @override
  Future<void> onLoad() async {
    // SpriteBatch from Flame
    var batch = await SpriteBatch.load('spritesheet.png');
    final sources = <Rect>[];
    for (var i = 0; i < 10; i++) {
      var rect = Rect.fromLTWH(i * 32, 0, 32, 32);
      sources.add(rect);
    }
    digitComponent = FlameDigitComponent(sources, batch, scale: 1);
    digitComponent.digitValue = 777;
    digitComponent.position = Vector2(25, 50);
    add(digitComponent);

    // other EngineBatch
    var image = await Flame.images.load('spritesheet.png');
    digitComponent2 = DigitComponent(image, tileSize: 32, scale: 1);
    digitComponent2.digitValue = 777;
    digitComponent2.position = Vector2(25, 80);
    add(digitComponent2);
  }

  @override
  void update(double dt) {
    super.update(dt);
    digitComponent.digitValue++;
    digitComponent2.digitValue++;
  }
}

void main() async {
  WidgetsFlutterBinding.ensureInitialized();
  final myGame = MyGame();
  runApp(
    GameWidget(
      game: myGame,
    ),
  );
}
