class DigitArray {
  //
  static final int digitsCount = 10;
  static final int maxDigits = 5;

  final List<int> _valueDigits;
  int _value = 0;
  bool valueChanged = true;
  int _count;

  DigitArray()
      : _valueDigits = List.filled(maxDigits, -1),
        _count = 1;

  void clear() {
    _value = 0;
    valueChanged = true;
    _count = 1;
  }

  int get characterCount => _count;

  int getDigitalFromIndex(int i) => _valueDigits[i];

  int get value => _value;

  set value(int value) {
    valueChanged = (_value != value);
    if (valueChanged) {
      _value = value;
      _count = intToDigitArray(_value, _valueDigits);
    }
  }

  static int intToDigitArray(int value, List<int> digits) {
    var count = getCount(value);
    var remainingValue = value;
    var index = 0;
    do {
      var number = remainingValue != 0 ? remainingValue % 10 : 0;
      remainingValue ~/= 10;
      digits[count - 1 - index] = number;
      index++;
    } while (remainingValue > 0 && index < digits.length);
    if (index < digits.length) {
      digits[index] = -1;
    }
    return count;
  }

  static int getCount(int value) {
    if (value >= 10000) {
      return 5;
    } else if (value >= 1000) {
      return 4;
    } else if (value >= 100) {
      return 3;
    } else if (value >= 10) {
      return 2;
    } else {
      return 1;
    }
  }
}
