import 'dart:ui';

import 'texture.dart';

abstract class Batch {
  void beginBatch(Canvas canvas);

  void endBatch();

  void drawTextureRegion(TextureRegion textureRegion, RSTransform transform);

  void drawTextureRegionFromData(
      TextureRegion textureRegion, double scos, double ssin, double tx, double ty);

  void drawImage(Image image, Rect rect, RSTransform transform);

  void drawImageFromData(Image image, Rect rect, double scos, double ssin, double tx, double ty);

  void drawImageFromComponents(
      {required Image image,
      required Rect rect,
      required double rotation,
      required double scale,
      required double anchorX,
      required double anchorY,
      required double translateX,
      required double translateY});
}
