import 'dart:ui';

import 'package:vector_math/vector_math_64.dart';

class TextureRegion {
  Texture texture;
  late final Rect rect;

  TextureRegion(this.texture) : rect = Rect.fromLTWH(0, 0, texture.size.x, texture.size.y);

  TextureRegion.fromImage(Image image, {Rect? rect})
      : texture = Texture.fromImage(image),
        rect = rect ?? Rect.fromLTWH(0, 0, image.width.toDouble(), image.height.toDouble());
}

class Texture {
  final Image image;
  final Vector2 _size;

  Texture.fromImage(this.image)
      : _size = Vector2(
          image.width.toDouble(),
          image.height.toDouble(),
        );

  Vector2 get size => _size;
}
